/*
	This Program is Based off of the SDK Test Application
	It will generate a list of the 100 possible combinations for a
	Masterlock combination lock given the last digit in the code.

	For a more complete description of the process, see:
	http://homepage.mac.com/joshpeek/masterlockcracker.html

	Thanks to them for the idea for the program
	(I didn't use their code, but I did use their method)

	Also thanks to Vanya Sergeev for his irda capture program.
	This program also utilizes some of his code.
	And also thanks to Shine for his PSP2PSP irda transfer program.

	Written by Brad Dwyer (aka Yeldarb) <Yeldarb@barbdwyer.com>
	This is Version .1 so don't expect this to be optimized
	(or good for that matter)
	This is my first app for the PSP; a learning experience.
*/
#include <pspkernel.h>
#include <pspctrl.h>
#include <pspdebug.h>
#include <pspdisplay.h>
#include <stdlib.h>
#include <string.h>

/* Define the module info section */
PSP_MODULE_INFO("Masterlock Cracker", 0, 1, 1);

/* Define the main thread's attribute value (optional) */
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);

/* Define printf, just to make typing easier */
#define printf	pspDebugScreenPrintf
#define REPEAT_TIME 0x40000
static unsigned long control_bef_ctl = 0;
static unsigned long control_bef_tick = 0; 

void dump_threadstatus(void);

/* Exit callback */
int exit_callback(void)
{
	sceKernelExitGame();

	return 0;
}

/* Callback thread */
void CallbackThread(void *arg)
{
	int cbid;

	//printf("\nCallback Thread Status:\n");
	dump_threadstatus();
	cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
	sceKernelRegisterExitCallback(cbid);

	sceKernelSleepThreadCB();
}

/* Dump the current thread's status */
void dump_threadstatus(void)
{
	int thid;
	ThreadStatus status;
	int ret;

	thid = sceKernelGetThreadId();
	memset(&status, 0, sizeof(ThreadStatus));
	//printf("Thread ID: %08X\n", thid);
	status.size = sizeof(ThreadStatus);
	ret = sceKernelReferThreadStatus(thid, &status); 
	//printf("Get Thread Status: %08X\n", ret);
	/*if(ret == 0)
	{
		printf("Name: %s\n", status.name);
		printf("Thread Addr: %08X\n", status.th_addr);
		printf("Stack Addr: %08X\n", status.stack_addr);
		printf("Stack Size: %08X\n", status.stack_size);
		printf("gp: %08X\n", status.gp);
		printf("Initial Pri: %x\n", status.init_pri);
		printf("Current Pri: %x\n", status.curr_pri);
	}*/
}

/* Sets up the callback thread and returns its thread id */
int SetupCallbacks(void)
{
	int thid = 0;

	thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);
	if(thid >= 0)
	{
		sceKernelStartThread(thid, 0, 0);
	}

	return thid;
}

unsigned long Read_Key(void) {
	ctrl_data_t key;

	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(1);
	sceCtrlReadBufferPositive(&key, 1);
	if (key.buttons == control_bef_ctl) {
		if ((key.frame - control_bef_tick) > REPEAT_TIME) {
			return control_bef_ctl;
		}
	}
	control_bef_ctl = key.buttons;
	control_bef_tick = key.frame;
	return control_bef_ctl;
}


int combos(int lastNum) {
	int modulus = lastNum % 4;
	int firstNum[10];
	int j = 0;
	int i = 0;
	printf("First Number : ");
	for(i=0; i<40; i++) {
		if(i%4 == modulus) {
			printf("%d ", i);
			firstNum[j] = i;
		}
	}

	int secondNum[10];
	int key=0;
	switch(modulus) {
		case 0:
			key = 2;
			break;
		case 1:
			key = 3;
			break;
		case 2:
			key = 0;
			break;
		case 3:
			key = 1;
			break;
		default:
			//How the Hell do you get anything other than 0-3
			//By doing something%4?
			//Obviously, something's wrong if this executes...
			break;
	}
	j = 0;
	printf("\n\nSecond Number: ");
	for(i=0; i<40; i++) {
		if(i%4 == key) {
			printf("%d ", i);
			secondNum[j] = i;
			j++;
		}
	}
	printf("\n\nLast Number  : ");
	printf("%d", lastNum);
	return 0;
}
int clrscreen() {
	int i=0;
	for(i=0; i<24; i++) {
		printf("\n");
	}
	return 0;
}

int displayIt(int theNum) {
	printf("Use the Arrows to Select the Last Number in the Combination\n\n");
	printf("Last Number: %d\n\n\n\n", theNum);
	combos(theNum);
}

int main(void)
{
	int lastNum = 0;
	unsigned long ctrl;

	pspDebugScreenInit();
	SetupCallbacks();

	displayIt(lastNum);
	while(1) {
		ctrl = Read_Key();
		if (ctrl & CTRL_LEFT) {
			if(lastNum > 0) {
				lastNum--;
				clrscreen();
				displayIt(lastNum);
			}
		}
		if (ctrl & CTRL_RIGHT) {
			if(lastNum < 39) {
				lastNum++;
				clrscreen();
				displayIt(lastNum);
			}
		}
	}

	//dump_threadstatus();
	sceKernelSleepThread();

	return 0;
}
